/* kerho.h */
/* Kerho-ohjelman tietorakenteen ksittely
**
**  Tekijt:          Vesa Lappalainen
**  Tehty:            09.12.1995
**  Muutettu          11.03.1996/vl
**  Mit muutettu:    listty harrasteet
**  Muutettu          27.12.2001/vl
**  Mit muutettu:    apufunktioita Kerhoon, suorat saantimetodit poistettu
**
*/

#ifndef __KERHO_H
#define __KERHO_H

#include <string>
using namespace std;
#include "jasenet.h"
#include "harsteet.h"


//----------------------------------------------------------------------------
// Kerhon mrittely:
//----------------------------------------------------------------------------

class cKerho {
  cJasenet jasenet;
  cHarrastukset harrastukset;

  void alusta()       {                                                      }
public:
  cKerho(int koko=0):jasenet(),harrastukset()  { alusta();                   }
  ~cKerho()           { talleta();                                           }

  string lue_tiedostosta(const string &tied);
  string talleta() { return jasenet.talleta() + harrastukset.talleta();      }

  const string &Kerhon_nimi()    const   { return jasenet.Koko_nimi();       }
  int Jasenia()                  const   { return jasenet.Lkm();             }
  // poista poistaa jsenistst ja harrasteista ne joilla on nro - tekemtt!
  int poista(int nro)                    { return 0;                         }
  int TeeBak(const string &bak_tark)     { return jasenet.TeeBak(bak_tark)+
                                               harrastukset.TeeBak(bak_tark);}
  string Tiedoston_nimi() const          { return jasenet.Tiedoston_nimi();  }
  string Bak_nimi() const                { return jasenet.Bak_nimi();        }
  const cHarrastus *eka_harrastus(int nro)     { return harrastukset.eka(nro);     }
  const cHarrastus *seuraava_harrastus(int nro){ return harrastukset.seuraava(nro);}
//  const cJasen *eka_jasen(int nro)             { return jasenet.eka(nro);          }
//  const cJasen *seuraava_jasen(int nro)        { return jasenet.seuraava(nro);     }
  string lisaa(const cHarrastus &har)     { return harrastukset.lisaa(har);  }
  string lisaa(const cJasen &jasen)       { return jasenet.lisaa(jasen);     }
  const cJasen &anna_jasen(int i) const   { return jasenet.anna(i);          }
};

#endif